
		; Shadow Warriors (Ocean) imager V1.0
		;
		; Note: Don't believe everything Stingray says on EAB! There
		; was no bug in the existing Patcher imager, but it has
		; been updated for RawDIC. Only tracks 2-139 are used
		; on disk 2, and the rest of the disk is not valid data.

		incdir	Include:
		include	RawDIC.i

		IFD	BARFLY
		OUTPUT	"ShadowWarriors.islave"
		IFND	.passchk
		DOSCMD	"WDate  >T:date"
.passchk
		ENDC
		ENDC

;=====================================================================

TRACK_SIZE	equ	$1600

;=====================================================================

		SLAVE_HEADER
		dc.b	1		; Slave version
		dc.b	0		; Slave flags
		dc.l	DSK_1_CL	; Pointer to the first disk structure
		dc.l	Text		; Pointer to the text displayed in the imager window

		dc.b	"$VER:"
Text:		dc.b	"Shadow Warriors imager V1.0",10
		dc.b	"by Codetapper/Action "
		IFD	BARFLY
		INCBIN	"T:date"
		ELSE
		dc.b	"(18.02.2015)"
		ENDC
		dc.b	0
		cnop	0,4

DSK_1_CL:	dc.l	DSK_2			; Pointer to next disk structure
		dc.w	1			; Disk structure version
		dc.w	DFLG_NORESTRICTIONS	; Disk flags
		dc.l	TL_1_CL			; List of tracks which contain data
		dc.l	0			; UNUSED, ALWAYS SET TO 0!
		dc.l	FL_DISKIMAGE		; List of files to be saved
		dc.l	CRC_1_CL		; Table of certain tracks with CRC values
		dc.l	DSK_1			; Alternative disk structure, if CRC failed
		dc.l	0			; Called before a disk is read
		dc.l	0			; Called after a disk has been read

DSK_1:		dc.l	DSK_2			; Pointer to next disk structure
		dc.w	1			; Disk structure version
		dc.w	DFLG_NORESTRICTIONS	; Disk flags
		dc.l	TL_1			; List of tracks which contain data
		dc.l	0			; UNUSED, ALWAYS SET TO 0!
		dc.l	FL_DISKIMAGE		; List of files to be saved
		dc.l	0			; Table of certain tracks with CRC values
		dc.l	0			; Alternative disk structure, if CRC failed
		dc.l	0			; Called before a disk is read
		dc.l	0			; Called after a disk has been read

DSK_2:		dc.l	0			; Pointer to next disk structure
		dc.w	1			; Disk structure version
		dc.w	DFLG_NORESTRICTIONS	; Disk flags
		dc.l	TL_2			; List of tracks which contain data
		dc.l	0			; UNUSED, ALWAYS SET TO 0!
		dc.l	FL_DISKIMAGE		; List of files to be saved
		dc.l	0			; Table of certain tracks with CRC values
		dc.l	0			; Alternative disk structure, if CRC failed
		dc.l	0			; Called before a disk is read
		dc.l	0			; Called after a disk has been read

TL_1		TLENTRY 000,159,TRACK_SIZE,SYNC_STD,DMFM_STD
		TLEND

TL_1_CL		TLENTRY 000,000,TRACK_SIZE,SYNC_STD,DMFM_STD
		TLENTRY 001,001,TRACK_SIZE,$448a,_DMFM_TDIC
		TLENTRY 002,159,TRACK_SIZE,SYNC_STD,DMFM_STD
		TLEND

TL_2		TLENTRY 002,139,TRACK_SIZE,SYNC_STD,_DMFM_Shadow
		;TLENTRY 140,159,TRACK_SIZE,SYNC_STD,DMFM_NULL
		TLEND
		EVEN

CRC_1_CL	CRCENTRY 000,$c0e1		;SPS 1679 copylock track 0
		CRCEND

;=====================================================================

_DMFM_Shadow	movem.l	d1-d7/a0-a6,-(sp)
		bsr	_Decoder
		movem.l	(sp)+,d1-d7/a0-a6
		rts

;=====================================================================

_DMFM_TDIC	move.l	#(TRACK_SIZE>>2)-1,d7	;Emulate DICs error
.CopyTDIC	move.l	#'TDIC',(a1)+		;handling :)
		dbf	d7,.CopyTDIC
		bra	_OK

;=====================================================================

_Decoder	move.l	d0,d5			;d5 = Track number
		move.l	#$55555555,d3		;d3 = Mask

		bsr	_DecodeLong
		cmp.w	d0,d5
		bne	_NoSector
		
		bsr	_DecodeLong
		move.l	d0,d2
		
		lea	$30(a0),a0

		move.l	a0,a2
		move.l	#(TRACK_SIZE>>1)-1,d7
.CheckLoop	move.l	(a2)+,d0
		and.l	d3,d0
		sub.l	d0,d2
		dbf	d7,.CheckLoop

		tst.l	d2
		bne	_Checksum

		move.l	#(TRACK_SIZE>>2)-1,d7
.DecodeLoop	bsr	_DecodeLong
		move.l	d0,(a1)+
		dbf	d7,.DecodeLoop

_OK		moveq	#IERR_OK,d0		;No error
		rts

_Checksum	moveq	#IERR_CHECKSUM,d0
		rts

_NoSector	moveq	#IERR_NOSECTOR,d0
		rts

;=====================================================================

_DecodeLong	move.l	(a0)+,d0
		move.l	(a0)+,d1
		and.l	d3,d0
		and.l	d3,d1
		add.l	d0,d0
		or.l	d1,d0
		rts
